#!/usr/bin/perl -w
# This script filters an error files.
# All *errors* are written to stderr.
# All *warnings* are written to stdout.

use strict;

#bibclean, bibparse and bibxmparse prefixes all errors with "??" and all
#warnings with "%%".

print STDERR "<meta http-equiv=\"expires\" content=\"0\"><html><body bgcolor=\"ffffff\">\n";
print "<meta http-equiv=\"expires\" content=\"0\"><html><body bgcolor=\"ffffff\">\n";

#Reading the input file
while (<>){


#Printing error messages to stderr
  if(/^\?\?(\.*)/){
    print STDERR "<p>$_</p>";
  }
  elsif(/^\%\%\.*/){
    print "<p>$_</p>";
  }
}
print STDERR "</html></body>";
print "</html></body>";
