/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOKEN_ABBREV = 1,
     TOKEN_AT = 2,
     TOKEN_COMMA = 3,
     TOKEN_COMMENT = 4,
     TOKEN_ENTRY = 5,
     TOKEN_EQUALS = 6,
     TOKEN_FIELD = 7,
     TOKEN_INCLUDE = 8,
     TOKEN_INLINE = 9,
     TOKEN_KEY = 10,
     TOKEN_LBRACE = 11,
     TOKEN_LITERAL = 12,
     TOKEN_NEWLINE = 13,
     TOKEN_PREAMBLE = 14,
     TOKEN_RBRACE = 15,
     TOKEN_SHARP = 16,
     TOKEN_SPACE = 17,
     TOKEN_STRING = 18,
     TOKEN_VALUE = 19
   };
#endif
#define TOKEN_ABBREV 1
#define TOKEN_AT 2
#define TOKEN_COMMA 3
#define TOKEN_COMMENT 4
#define TOKEN_ENTRY 5
#define TOKEN_EQUALS 6
#define TOKEN_FIELD 7
#define TOKEN_INCLUDE 8
#define TOKEN_INLINE 9
#define TOKEN_KEY 10
#define TOKEN_LBRACE 11
#define TOKEN_LITERAL 12
#define TOKEN_NEWLINE 13
#define TOKEN_PREAMBLE 14
#define TOKEN_RBRACE 15
#define TOKEN_SHARP 16
#define TOKEN_SPACE 17
#define TOKEN_STRING 18
#define TOKEN_VALUE 19




/* Copy the first part of user declarations.  */
#line 1 "bibxmlparse.y"

#include <config.h>

#include <stdio.h>
#include <string.h>


static void doparse(void);
int main(int, char**);
static int nextchar(void);
static void recognize(const char*);
int yyparse (void);
static void yywarning (const char*);

#if defined(__cplusplus)
extern "C" {
#endif

static int (*pyylex)(void);
int xxlex(void);
int	zzlex (void);

#if defined(__cplusplus)
}
#endif

int error_count;

/* These variables are defined in biblex.c: */
extern int do_lex_output;
extern long line_number;
extern const char *the_filename;
extern char yytext[BIBYYLMAX];

#define	ERROR_PREFIX	"??"	/* this prefixes all error messages */
#define WARNING_PREFIX	"%%"	/* this prefixes all warning messages */

#define RECOGNIZE(s)	recognize(s)

#define YYDEBUG		1		/* need for -d option support */

#if defined(_CRAY)
extern long yydebug;
#else
extern int yydebug;
#endif



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 51 "bibxmlparse.y"
typedef union YYSTYPE {
  char *sval;
  int ival;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 172 "bibxmlparse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 184 "bibxmlparse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   74

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  22
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  29
/* YYNRULES -- Number of rules. */
#define YYNRULES  47
/* YYNRULES -- Number of states. */
#define YYNSTATES  86

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   257

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    15,    19,    21,    23,
      25,    27,    29,    32,    33,    38,    42,    48,    51,    52,
      53,    64,    66,    68,    69,    74,    75,    84,    85,    94,
      96,    97,    98,   106,   108,   110,   112,   117,   118,   126,
     128,   130,   131,   133,   135,   138,   140,   142
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      23,     0,    -1,    48,    -1,    48,    24,    48,    -1,    25,
      -1,    24,    48,    25,    -1,     4,    48,    26,    -1,    27,
      -1,    29,    -1,    34,    -1,    36,    -1,    38,    -1,     1,
      17,    -1,    -1,     6,    28,    48,    14,    -1,    30,    44,
      17,    -1,    30,    44,     5,    48,    17,    -1,    30,    17,
      -1,    -1,    -1,     7,    31,    48,    13,    48,    33,    32,
      48,     5,    48,    -1,    12,    -1,     3,    -1,    -1,    10,
      35,    48,    14,    -1,    -1,    16,    37,    48,    13,    48,
      40,    48,    17,    -1,    -1,    20,    39,    48,    13,    48,
      45,    48,    17,    -1,    43,    -1,    -1,    -1,    40,    48,
      41,    18,    42,    48,    43,    -1,    21,    -1,     3,    -1,
      45,    -1,    44,     5,    48,    45,    -1,    -1,    47,    48,
       8,    48,    46,    40,    48,    -1,     9,    -1,     3,    -1,
      -1,    49,    -1,    50,    -1,    49,    50,    -1,    19,    -1,
      11,    -1,    15,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   121,   121,   123,   127,   129,   133,   139,   143,   147,
     151,   155,   159,   166,   165,   177,   183,   191,   198,   205,
     197,   215,   220,   227,   226,   239,   238,   253,   252,   266,
     271,   273,   270,   278,   282,   289,   291,   299,   297,   308,
     314,   326,   327,   331,   333,   337,   338,   339
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOKEN_ABBREV", "TOKEN_AT",
  "TOKEN_COMMA", "TOKEN_COMMENT", "TOKEN_ENTRY", "TOKEN_EQUALS",
  "TOKEN_FIELD", "TOKEN_INCLUDE", "TOKEN_INLINE", "TOKEN_KEY",
  "TOKEN_LBRACE", "TOKEN_LITERAL", "TOKEN_NEWLINE", "TOKEN_PREAMBLE",
  "TOKEN_RBRACE", "TOKEN_SHARP", "TOKEN_SPACE", "TOKEN_STRING",
  "TOKEN_VALUE", "$accept", "file", "object_list", "object", "at_object",
  "comment", "@1", "entry", "entry_head", "@2", "@3", "key_name",
  "include", "@4", "preamble", "@5", "string", "@6", "value", "@7", "@8",
  "simple_value", "assignment_list", "assignment", "@9", "assignment_lhs",
  "opt_space", "space", "single_space", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    22,    23,    23,    24,    24,    25,    26,    26,    26,
      26,    26,    26,    28,    27,    29,    29,    29,    31,    32,
      30,    33,    33,    35,    34,    37,    36,    39,    38,    40,
      41,    42,    40,    43,    43,    44,    44,    46,    45,    47,
      47,    48,    48,    49,    49,    50,    50,    50
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     2,     0,     4,     3,     5,     2,     0,     0,
      10,     1,     1,     0,     4,     0,     8,     0,     8,     1,
       0,     0,     7,     1,     1,     1,     4,     0,     7,     1,
       1,     0,     1,     1,     2,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      41,    46,    47,    45,     0,     2,    42,    43,     1,    41,
      41,     4,    44,     0,     3,     0,    13,    18,    23,    25,
      27,     6,     7,     8,     0,     9,    10,    11,     5,    12,
      41,    41,    41,    41,    41,    40,    39,    17,     0,    35,
      41,     0,     0,     0,     0,     0,    41,    15,     0,    14,
      41,    24,    41,    41,     0,    41,     0,     0,     0,    16,
      36,    37,    22,    21,    19,    34,    33,    41,    29,    41,
       0,    41,    30,     0,    41,     0,    26,     0,    28,    38,
      41,    31,    20,    41,     0,    32
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     4,    10,    11,    21,    22,    30,    23,    24,    31,
      71,    64,    25,    32,    26,    33,    27,    34,    67,    77,
      83,    68,    38,    39,    70,    40,     5,     6,     7
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -40
static const yysigned_char yypact[] =
{
      21,   -40,   -40,   -40,     5,     2,    21,   -40,   -40,    21,
      21,   -40,   -40,    10,     2,    12,   -40,   -40,   -40,   -40,
     -40,   -40,   -40,   -40,     1,   -40,   -40,   -40,   -40,   -40,
      21,    21,    21,    21,    21,   -40,   -40,   -40,    -3,   -40,
      21,    -6,    20,    24,    22,    26,    21,   -40,    37,   -40,
      21,   -40,    21,    21,    25,    21,     0,     6,     4,   -40,
     -40,   -40,   -40,   -40,   -40,   -40,   -40,    21,   -40,    21,
       6,    21,    30,    31,    21,    44,   -40,    32,   -40,    33,
      21,   -40,   -40,    21,     6,   -40
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -40,   -40,   -40,    38,   -40,   -40,   -40,   -40,   -40,   -40,
     -40,   -40,   -40,   -40,   -40,   -40,   -40,   -40,   -17,   -40,
     -40,   -30,   -40,   -39,   -40,   -40,    -9,   -40,    49
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -31
static const yysigned_char yytable[] =
{
      13,    14,    46,    62,    35,     8,     9,    35,    49,    65,
      36,    15,    63,    36,    47,    60,    16,    17,    37,    69,
      18,    41,    42,    43,    44,    45,    19,    66,    35,    29,
      20,    48,     1,    50,    36,    52,     2,    54,    51,    53,
       3,    56,    59,    57,    58,    55,    61,    76,    78,    80,
      81,   -30,    28,    74,    85,    12,     0,     0,    72,     0,
      73,     0,    75,     0,     0,    79,     0,     0,     0,     0,
       0,    82,     0,     0,    84
};

static const yysigned_char yycheck[] =
{
       9,    10,     5,     3,     3,     0,     4,     3,    14,     3,
       9,     1,    12,     9,    17,    54,     6,     7,    17,    58,
      10,    30,    31,    32,    33,    34,    16,    21,     3,    17,
      20,    40,    11,    13,     9,    13,    15,    46,    14,    13,
      19,    50,    17,    52,    53,     8,    55,    17,    17,     5,
      18,    18,    14,    70,    84,     6,    -1,    -1,    67,    -1,
      69,    -1,    71,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      -1,    80,    -1,    -1,    83
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    11,    15,    19,    23,    48,    49,    50,     0,     4,
      24,    25,    50,    48,    48,     1,     6,     7,    10,    16,
      20,    26,    27,    29,    30,    34,    36,    38,    25,    17,
      28,    31,    35,    37,    39,     3,     9,    17,    44,    45,
      47,    48,    48,    48,    48,    48,     5,    17,    48,    14,
      13,    14,    13,    13,    48,     8,    48,    48,    48,    17,
      45,    48,     3,    12,    33,     3,    21,    40,    43,    45,
      46,    32,    48,    48,    40,    48,    17,    41,    17,    48,
       5,    18,    48,    42,    48,    43
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 122 "bibxmlparse.y"
    {RECOGNIZE("file-1");}
    break;

  case 3:
#line 124 "bibxmlparse.y"
    {RECOGNIZE("file-2");}
    break;

  case 4:
#line 128 "bibxmlparse.y"
    {RECOGNIZE("object-1");}
    break;

  case 5:
#line 130 "bibxmlparse.y"
    {RECOGNIZE("object-2");}
    break;

  case 6:
#line 134 "bibxmlparse.y"
    {
			    RECOGNIZE("object");
			}
    break;

  case 7:
#line 140 "bibxmlparse.y"
    {  
			  RECOGNIZE("comment");
			}
    break;

  case 8:
#line 144 "bibxmlparse.y"
    {
			  RECOGNIZE("entry");
			}
    break;

  case 9:
#line 148 "bibxmlparse.y"
    {
			  RECOGNIZE("include");
			}
    break;

  case 10:
#line 152 "bibxmlparse.y"
    {
			  RECOGNIZE("preamble");
			}
    break;

  case 11:
#line 156 "bibxmlparse.y"
    {
			  RECOGNIZE("string");
			}
    break;

  case 12:
#line 160 "bibxmlparse.y"
    {
			  RECOGNIZE("error");
			}
    break;

  case 13:
#line 166 "bibxmlparse.y"
    {
			  printf("<Comment>");
			}
    break;

  case 14:
#line 171 "bibxmlparse.y"
    {
			  printf("%s</Comment>",(yyvsp[0].sval));
			  RECOGNIZE("comment");
			}
    break;

  case 15:
#line 180 "bibxmlparse.y"
    {
			  RECOGNIZE("entry-1");
			}
    break;

  case 16:
#line 187 "bibxmlparse.y"
    {
			  RECOGNIZE("entry-2");
			  printf("</%s>\n\n",(yyvsp[-4].sval));
			}
    break;

  case 17:
#line 192 "bibxmlparse.y"
    {
			  RECOGNIZE("entry-3");
			}
    break;

  case 18:
#line 198 "bibxmlparse.y"
    {
			    printf("<%s>\n",(yyvsp[0].sval));
			    (yyval.sval)=strdup((yyvsp[0].sval));
			}
    break;

  case 19:
#line 205 "bibxmlparse.y"
    {
			    printf("<label>%s</label>\n",(yyvsp[0].sval));
			}
    break;

  case 20:
#line 210 "bibxmlparse.y"
    {
			    RECOGNIZE("entry_head");
			}
    break;

  case 21:
#line 216 "bibxmlparse.y"
    {
			  (yyval.sval)=strdup((yyvsp[0].sval));
			  RECOGNIZE("key_name-1");
			}
    break;

  case 22:
#line 221 "bibxmlparse.y"
    {
			  RECOGNIZE("key_name-2");
			}
    break;

  case 23:
#line 227 "bibxmlparse.y"
    {
			  printf("<Include>");
			}
    break;

  case 24:
#line 232 "bibxmlparse.y"
    {
			  printf("<Include>");
			  RECOGNIZE("include");
			}
    break;

  case 25:
#line 239 "bibxmlparse.y"
    {
			  printf("<Preamble>");
			}
    break;

  case 26:
#line 246 "bibxmlparse.y"
    {
			  printf("</Preamble>");
			  RECOGNIZE("preamble");
			}
    break;

  case 27:
#line 253 "bibxmlparse.y"
    {
			  printf("<String>");
			}
    break;

  case 28:
#line 260 "bibxmlparse.y"
    {
			  printf("</macrotext></String>\n\n");
			  RECOGNIZE("string");
			}
    break;

  case 29:
#line 267 "bibxmlparse.y"
    {
			    RECOGNIZE("value-1");
			}
    break;

  case 30:
#line 271 "bibxmlparse.y"
    {RECOGNIZE("value-1-1");}
    break;

  case 31:
#line 273 "bibxmlparse.y"
    {RECOGNIZE("value-1-2");}
    break;

  case 32:
#line 275 "bibxmlparse.y"
    {RECOGNIZE("value-2");}
    break;

  case 33:
#line 279 "bibxmlparse.y"
    {
			    printf("%s",(yyvsp[0].sval));
			    RECOGNIZE("simple_value-1");}
    break;

  case 34:
#line 283 "bibxmlparse.y"
    {
			    printf("<ref>%s</ref>",(yyvsp[0].sval));
			    RECOGNIZE("simple_value-2");
			}
    break;

  case 35:
#line 290 "bibxmlparse.y"
    {RECOGNIZE("single assignment");}
    break;

  case 36:
#line 294 "bibxmlparse.y"
    {RECOGNIZE("assignment-list");}
    break;

  case 37:
#line 299 "bibxmlparse.y"
    {RECOGNIZE("assignment-0");}
    break;

  case 38:
#line 301 "bibxmlparse.y"
    {
			    if(strcmp((yyvsp[-6].sval),"donotclose"))/*caccamo*/
				printf("</%s>\n",(yyvsp[-6].sval));
			    RECOGNIZE("assignment");
			}
    break;

  case 39:
#line 309 "bibxmlparse.y"
    {
                           printf("<%s>",(yyvsp[0].sval));
			   (yyval.sval)=strdup((yyvsp[0].sval));
                           RECOGNIZE("assignment_lhs-1");
                         }
    break;

  case 40:
#line 315 "bibxmlparse.y"
    {
			  if(!strcmp((yyvsp[0].sval),"comment"))
			    printf("<comment>%s</comment>",(yyvsp[0].sval)); /*caccamo*/
			  else
			    printf("<alias>%s</alias><macrotext>", (yyvsp[0].sval));
			  (yyval.sval)="donotclose";/*caccamo*/
			  RECOGNIZE("assignment_lhs-2");
			}
    break;

  case 41:
#line 326 "bibxmlparse.y"
    {RECOGNIZE("opt_space-1");}
    break;

  case 42:
#line 328 "bibxmlparse.y"
    {RECOGNIZE("opt_space-2");}
    break;

  case 43:
#line 332 "bibxmlparse.y"
    {RECOGNIZE("single space");}
    break;

  case 44:
#line 334 "bibxmlparse.y"
    {RECOGNIZE("multiple spaces");}
    break;


    }

/* Line 1037 of yacc.c.  */
#line 1450 "bibxmlparse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 341 "bibxmlparse.y"


/* end of grammar */

static void doparse(void)
{
    /* parse a complete BibTeX file or BibTeX token stream */
    int c;

    line_number = 1L;

    /* A single character lookahead distinguishes between a token
    stream, which starts with a line number directive, and a BibTeX
    file, which does not.  We then pick a suitable lexical analyzer
    function. */

    c = getchar();
    (void)ungetc(c, stdin);
    
    pyylex = (c == '#') ? zzlex : xxlex;
    

    yyparse();				/* this handles the entire file */
}


int main(int argc, char *argv[])
{
    int code; /* error return code */
    int k;    /* index into argv[] */
    int n;    /* index into argv[] */
    FILE *fp; /* pointer to current input file */

    do_lex_output = 0;			/* prevent output from xxlex() */
    error_count = 0;
    for(k = 1; k < argc; ++k) {					/* check for command-line options */
        if((strcmp(argv[k],"-d") == 0) || (strcmp(argv[k],"-D") == 0)) {
            yydebug = 1;
            do_lex_output = 1;
            for (n = k; n < argc; ++n)	/* shuffle remaining arguments down */
                argv[n] = argv[n+1];
            argc--;			/* and reduce argument count */
        }
    }
    printf("<?xml version=\"1.0\" encoding=\"UTF-8\"?><bibxml>");
    if (argc > 1) {		/* files to parse named on command line */
        for (k = 1; k < argc; ++k) {
            fp = freopen(argv[k], "r", stdin);
            if (fp == (FILE*)NULL) {
                (void)fprintf(stderr,
                              "\n%s Ignoring open failure on file [%s]\n",
                              ERROR_PREFIX, argv[k]);
                (void)perror("perror() says");
            } else {
                the_filename = argv[k];
                doparse();
                (void)fclose(fp);
            }
        }
    } else {				/* parse stdin */
        the_filename = "stdin";
        doparse();
    }
    printf("</bibxml>\n");
    return (error_count > 0) ? EXIT_FAILURE : EXIT_SUCCESS;
}


static int nextchar(void)
{
    int c;

    c = getchar();
    if (yydebug)
        putchar (c);
    return c;
}


static void recognize(const char *s)
{
    if (yydebug)
        printf("[%s]\n", s);
}


void yyerror(const char *s)
{
    error_count++;
    (void)fflush(stdout);
    (void)fprintf(stderr,"%s \"%s\", line %ld: %s\tNext token = \"%s\"\n",
                  ERROR_PREFIX, the_filename, line_number, s, yytext);
    (void)fflush(stderr);
}


int yylex(void)
{
    int v;
    v = (*pyylex) ();

    /* xxlex() (== yylex() in biblex.c) biases token values by 1000, but
       the token streams produced by biblex and "bibclean --no-prettyprint"
       exclude that bias, for compact output. */

    return ((pyylex == zzlex) ? v : (v - 1000));
}


static void yywarning(const char *s)
{
    (void)fflush(stdout);
    (void)fprintf(stderr,"%s %s\tNext token = \"%s\"\n",
		  WARNING_PREFIX, s, yytext);
    (void)fflush(stderr);
}


int zzlex(void)
{
    char buffer[BUFSIZ];	/* only needs space for a single number token */
    char *limit;		/* how far we can store into buffer[] */
    char *p;			/* pointer into buffer[] */
    int c;			/* current input character */

    limit = &buffer[sizeof(buffer) - 1]; /* address of last slot in buffer[] */

    for (;;) {			/* `infinite' loop for ignoring comments and empty lines */
        while (((c = nextchar ()) > 0) && isspace (c))
            ;			/* skip leading whitespace */

        /* Collect first non-blank token on line, truncating if too big for buffer[] */
        p = &buffer[0];
        *p++ = c;
        while (((c = nextchar ()) > 0) && !isspace (c)) {
            if (p < limit)
                *p++ = c;
        }
        *p = '\0';

        while ((c != '\n') && ((c = nextchar ()) > 0))
            ;			/* skip rest of line */

        if (c == '\n')		/* should always be true */
            line_number++;

        if (buffer[0] == '#')	/* comment: pseudo return tail-recursively */
            continue;
        else if (isdigit ((int) buffer[0]))	/* token number */
            return ((int) strtol ((const char *) &buffer[0], &limit, 10));
        else if (c == '\n')	/* empty line: pseudo return tail-recursively */
            continue;
        else if (feof (stdin))	/* assume end of file */
            return (0);		/* standard lex end-of-file signal */
        else
            return (-1);	/* should never happen */
    }
}

